#include <iostream>
#include <string>
#include <vector>
#include <cassert>

using namespace std;
int main()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    vector<vector<int>> table(26, vector<int>(26, 0));
    vector<vector<int>> get_next(26, vector<int>(26, 0));
    for (int i = 0; i < 26; ++i) {
        for (int j = 0; j < 26; ++j) {
            table[i][j] = (i + j) % 26;
            get_next[i][(i + j) % 26] = j;
        }
    }

    std::string chr;
    cin >> chr;
    bool ok = 0;

    auto res = chr;
    for (int j = 0; j < 26; ++j) {
        res[0] = 'A' + j;
        for (int i = 1; i < chr.size(); ++i) {
            int idx1 = res[i - 1] - 'A';
            int idx_p = chr[i - 1] - 'A';
            int idx2 = get_next[idx1][idx_p];
            res[i] = 'A' + idx2;
        }
        int idx1 = res.back() - 'A';
        int idx2 = chr[0] - 'A';
        if (table[idx1][idx2] == chr.back() - 'A') {
            ok = 1;
            break;
        }
    }
    if (ok) {
        cout << res << "\n";
    } else {
        assert(0);
    }
    return 0;
}