#include <iostream>
#include <fstream>
#include <string>

#define assert_input(expr)    if (!(expr)) { std::cout << 3; return 3; }

std::string encrypt(std::string line)
{
  int first = -1;
  for (int i = 0; line[i] != 0 && line[i] != 10; ++i) {
    if (line[i] < 65 || line[i] > 90) {
      if (first >= 0 && first != i-1) {
        line[i-1] = (line[i-1] + line[first] - 130) % 26 + 65;
      }
      first = -1;
      continue;
    }
    if (first < 0) {
      first = i;
      continue;
    }
    line[i-1] = (line[i-1] + line[i] - 130) % 26 + 65;
  }
  return line;
}

int main(int argc, char** argv)
{
  std::ifstream input(argv[1]);
  std::ifstream output(argv[2]);
  std::ifstream answer(argv[3]);

  std::string ans, ans_contestant;
  assert_input(std::getline(output, ans_contestant));
  if (ans_contestant.empty()) {
    std::cout << 2;
    return 2;
  }

  assert_input(std::getline(answer, ans));
  if (encrypt(ans) == encrypt(ans_contestant)) {
    std::cout << 0;
    return 0;
  }

  std::cout << 1;
  return 1;
}