#!/usr/bin/env python

import random as rnd
rnd.seed(123)

def write_test(n, test_str):
    filename = "{:0>2}".format(n)
    filename += ".in"
    f = open(filename, "w")
    f.write(test_str)

class TestGen:
    def __init__(self, first_testno):
        self.testno = first_testno
    def next_test(self, teststr):
        write_test(self.testno, teststr)
        self.testno += 1

def random_str(n):
    return ''.join([chr(ord('A') + rnd.randint(0, 25)) for _ in range(n)])


gen = TestGen(2)
gen.next_test(random_str(2))
gen.next_test(random_str(5))
gen.next_test(random_str(9))
gen.next_test(random_str(10))
gen.next_test(random_str(10))
gen.next_test(random_str(10))
gen.next_test(random_str(10))

gen.next_test(random_str(50))
gen.next_test(random_str(50))
gen.next_test(random_str(50))
gen.next_test(random_str(50))
gen.next_test(random_str(75))
gen.next_test(random_str(75))
gen.next_test(random_str(99))

gen.next_test(random_str(100))
gen.next_test(random_str(100))
gen.next_test(random_str(100))
gen.next_test(random_str(100))
gen.next_test(random_str(105))
gen.next_test(random_str(100))
gen.next_test(random_str(100))
gen.next_test(random_str(100))

gen.next_test(random_str(1000))
gen.next_test(random_str(1000))
gen.next_test(random_str(1000))
gen.next_test(random_str(1000))
gen.next_test(random_str(1000))
gen.next_test(random_str(1000))

gen.next_test(random_str(10000))
gen.next_test(random_str(10000))
gen.next_test(random_str(10000))
gen.next_test(random_str(10000))
gen.next_test(random_str(10000))

gen.next_test(random_str(100000))
gen.next_test(random_str(100000))
gen.next_test(random_str(100000))
gen.next_test(random_str(100000))
gen.next_test(random_str(100000))
gen.next_test(random_str(100000))